package com.denizenscript.clientizen.debuggui;

import com.denizenscript.clientizen.mixin.gui.WScrollPanelAccessor;
import com.denizenscript.clientizen.mixin.gui.WTextAccessor;
import com.denizenscript.denizencore.utilities.ReflectionHelper;
import io.github.cottonmc.cotton.gui.client.BackgroundPainter;
import io.github.cottonmc.cotton.gui.widget.WPlainPanel;
import io.github.cottonmc.cotton.gui.widget.WScrollBar;
import io.github.cottonmc.cotton.gui.widget.WScrollPanel;
import io.github.cottonmc.cotton.gui.widget.WText;
import io.github.cottonmc.cotton.gui.widget.data.Axis;
import io.github.cottonmc.cotton.gui.widget.data.Color;
import io.github.cottonmc.cotton.gui.widget.data.InputResult;
import io.github.cottonmc.cotton.gui.widget.data.Insets;
import net.fabricmc.fabric.api.client.networking.v1.ClientLoginConnectionEvents;
import net.fabricmc.fabric.api.util.TriState;
import net.minecraft.class_1041;
import net.minecraft.class_2561;
import net.minecraft.class_310;
import java.util.ArrayList;
import java.util.List;

public class DebugConsole extends WScrollPanel {

    public static StringBuilder debugText = new StringBuilder();

    static {
        ClientLoginConnectionEvents.DISCONNECT.register((handler, client) -> {
            debugText = new StringBuilder();
        });
    }

    public static ConsoleTextArea textArea;

    public static void addDebug(String debug) {
        if (!debugText.isEmpty()) {
            debugText.append('\n').append(debug);
        }
        else {
            debugText.append(debug);
        }
        if (textArea != null) {
            textArea.addLine(debug);
        }
    }

    public class_310 client = class_310.method_1551();

    public DebugConsole() {
        super(new WPlainPanel());
        class_1041 window = client.method_22683();
        setScrollingHorizontally(TriState.FALSE);
        setBackgroundPainter(BackgroundPainter.createColorful(Color.BLACK.toRgb()));
        setSize(window.method_4486(), window.method_4502() - ClientizenDebugGUI.TAB_HEIGHT);

        children.remove(verticalScrollBar);
        verticalScrollBar = new CustomScrollBar(Axis.VERTICAL, 20);
        verticalScrollBar.setParent(this);
        children.add(verticalScrollBar);

        WPlainPanel heldPanel = (WPlainPanel) ((WScrollPanelAccessor) this).getWidget();
        heldPanel.setInsets(new Insets(5, 5, 0, 0));
        textArea = new ConsoleTextArea(debugText.toString());
        heldPanel.setSize(window.method_4486(), textArea.getHeight());
        heldPanel.add(textArea, 0, 0);
    }

    public void onClose() {
        textArea = null;
    }

    public static class CustomScrollBar extends WScrollBar {

        public int scrollSpeed;

        public CustomScrollBar(Axis axis, int scrollSpeed) {
            super(axis);
            this.scrollSpeed = scrollSpeed;
        }

        @Override
        public InputResult onMouseScroll(int x, int y, double amount) { // Same as super method, but uses a custom scrolling speed
            setValue(getValue() + (int) -amount * scrollSpeed);
            return InputResult.PROCESSED;
        }
    }

    public class ConsoleTextArea extends WText {

        public WTextAccessor accessor = (WTextAccessor) this;

        public ConsoleTextArea(String debug) {
            super(class_2561.method_43470(debug));
            accessor.setWrappedLines(new ArrayList<>(client.field_1772.method_1728(text, client.method_22683().method_4486())));
            updateSize(false);
        }

        public void addLine(String line) {
            accessor.getWrappedLines().addAll(client.field_1772.method_1728(class_2561.method_43470(line), client.method_22683().method_4486()));
            updateSize(true);
        }

        public void updateSize(boolean updateScroll) {
            setSize(width, client.field_1772.field_2000 * accessor.getWrappedLines().size());
            if (updateScroll) {
                boolean wasAtBottom = verticalScrollBar.getValue() == verticalScrollBar.getMaxScrollValue();
                DebugConsole.this.layout(); // update the scroll panel to resize the scroll bar
                if (wasAtBottom) {
                    verticalScrollBar.setValue(verticalScrollBar.getMaxScrollValue());
                }
            }
            accessor.setWrappingScheduled(false);
        }

        @Override
        public boolean canResize() {
            return false;
        }

    }

}
